/*
 * Digitale Dörfer Plattform
 * Copyright (C) Fraunhofer IESE 2016 - 2020 Alberto Lara, Balthasar Weitzel, Dominik Schnier
 *
 * SPDX-License-Identifier: Apache-2.0
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package de.fhg.iese.dd.platform.api.communication;

import static org.junit.jupiter.api.Assertions.assertEquals;
import static org.junit.jupiter.api.Assertions.assertFalse;
import static org.junit.jupiter.api.Assertions.assertNull;
import static org.junit.jupiter.api.Assertions.assertTrue;
import static org.springframework.test.web.servlet.request.MockMvcRequestBuilders.post;
import static org.springframework.test.web.servlet.result.MockMvcResultMatchers.status;

import java.util.Collections;
import java.util.Objects;
import java.util.concurrent.TimeUnit;

import org.apache.commons.lang3.StringUtils;
import org.junit.jupiter.api.Test;
import org.mockito.Mockito;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.mock.mockito.SpyBean;
import org.springframework.test.web.servlet.MvcResult;

import de.fhg.iese.dd.platform.api.BaseServiceTest;
import de.fhg.iese.dd.platform.api.BaseTestHelper;
import de.fhg.iese.dd.platform.api.communication.clientevent.ClientChatMessageReceivedEvent;
import de.fhg.iese.dd.platform.api.communication.clientevent.ClientChatMessageSendRequest;
import de.fhg.iese.dd.platform.api.communication.clientevent.ClientChatMessageSentConfirmation;
import de.fhg.iese.dd.platform.api.communication.clientevent.ClientChatReadRequest;
import de.fhg.iese.dd.platform.api.communication.clientmodel.ClientChatMessage;
import de.fhg.iese.dd.platform.business.shared.push.providers.TestExternalPushProvider;
import de.fhg.iese.dd.platform.datamanagement.communication.config.CommunicationConfig;
import de.fhg.iese.dd.platform.datamanagement.communication.model.Chat;
import de.fhg.iese.dd.platform.datamanagement.communication.model.ChatParticipant;
import de.fhg.iese.dd.platform.datamanagement.framework.exceptions.ClientExceptionType;
import de.fhg.iese.dd.platform.datamanagement.participants.person.model.Person;
import de.fhg.iese.dd.platform.datamanagement.participants.personblocking.model.PersonBlocking;
import de.fhg.iese.dd.platform.datamanagement.shared.files.model.TemporaryMediaItem;
import de.fhg.iese.dd.platform.datamanagement.shared.push.model.PushCategory;

public class ChatEventControllerTest extends BaseServiceTest {

    @Autowired
    private CommunicationConfig communicationConfig;

    @Autowired
    private CommunicationTestHelper th;

    @SpyBean
    private TestExternalPushProvider testExternalPushProvider;

    @Override
    public void tearDown() throws Exception {
        th.deleteAllData();
    }

    @Override
    public void createEntities() {
        th.createTenantsAndGeoAreas();
        th.createAchievementRules();
        th.createPersons();
        th.createAppEntities();
        th.createChatEntities();
    }

    @Test
    public void chatMessageSendRequest() throws Exception {

        String message = "Testing sendMessage from ChatController ☺";
        long sentTime = System.currentTimeMillis();
        String chatId = th.chat1.getId();
        Person sender = th.chat1Participant2.getPerson();
        Person receiver = th.chat1Participant1.getPerson();

        ClientChatMessageSendRequest chatMessageSendRequest = ClientChatMessageSendRequest.builder()
                .chatId(chatId)
                .message(message)
                .sentTime(sentTime)
                .build();

        MvcResult result = mockMvc.perform(post("/communication/chat/event/chatMessageSendRequest")
                .headers(authHeadersFor(sender))
                .contentType(contentType)
                .content(json(chatMessageSendRequest)))
                .andReturn();

        ClientChatMessageSentConfirmation clientChatMessageSentConfirmation =
                toObject(result.getResponse(),
                        ClientChatMessageSentConfirmation.class);

        ClientChatMessage sentChatMessage = clientChatMessageSentConfirmation.getChatMessage();
        assertEquals(sentTime, sentChatMessage.getSentTime());
        assertFalse(sentChatMessage.isAutoGenerated());
        assertEquals(chatId, sentChatMessage.getChatId());
        assertEquals(message, sentChatMessage.getMessage());
        assertEquals(sender.getId(), sentChatMessage.getSenderId());

        // verify push messages
        waitForEventProcessing();

        ClientChatMessageReceivedEvent loudPushedEvent = testClientPushService.getPushedEventToPersonLoud(sender,
                receiver,
                ClientChatMessageReceivedEvent.class,
                new PushCategory.PushCategoryId(th.chat1SubjectPushCategory.getId()));

        assertEquals(loudPushedEvent.getChatId(), chatId);
        // We expect a loud push from a loud push event
        Mockito.verify(testExternalPushProvider).sendMessageToPerson(Mockito.anySet(), Mockito.eq(receiver),
                Mockito.any(), Mockito.eq(true));

        ClientChatMessageReceivedEvent silentPushedEvent = testClientPushService.getPushedEventToPersonSilent(
                sender,
                ClientChatMessageReceivedEvent.class,
                Collections.singletonList(th.chat1SubjectPushCategory));

        assertEquals(silentPushedEvent.getChatId(), chatId);
        Mockito.verify(testExternalPushProvider).sendMessageToPerson(Mockito.anySet(), Mockito.eq(sender),
                Mockito.any(), Mockito.eq(false));

        testClientPushService.assertNoMorePushedEvents();
    }

    @Test
    public void chatMessageSendRequest_TextAndMediaMessage() throws Exception {

        String message = "Testing sendMessage from ChatController ☺ with image 📷";
        long sentTime = System.currentTimeMillis();
        String chatId = th.chat1.getId();
        Person sender = th.chat1Participant2.getPerson();

        TemporaryMediaItem temporaryMediaItem = th.createTemporaryMediaItem(sender, sentTime + 100, sentTime);

        ClientChatMessageSendRequest chatMessageSendRequest = ClientChatMessageSendRequest.builder()
                .chatId(chatId)
                .message(message)
                .temporaryMediaItemId(temporaryMediaItem.getId())
                .sentTime(sentTime)
                .build();

        MvcResult result = mockMvc.perform(post("/communication/chat/event/chatMessageSendRequest")
                .headers(authHeadersFor(sender))
                .contentType(contentType)
                .content(json(chatMessageSendRequest)))
                .andReturn();

        ClientChatMessageSentConfirmation clientChatMessageSentConfirmation =
                toObject(result.getResponse(),
                        ClientChatMessageSentConfirmation .class);

        ClientChatMessage sentChatMessage = clientChatMessageSentConfirmation.getChatMessage();

        assertEquals(sentTime, sentChatMessage.getSentTime());
        assertFalse(sentChatMessage.isAutoGenerated());
        assertEquals(chatId, sentChatMessage.getChatId());
        assertEquals(message, sentChatMessage.getMessage());
        assertEquals(temporaryMediaItem.getMediaItem().getId(), sentChatMessage.getMediaItem().getId());
        assertEquals(sender.getId(),sentChatMessage.getSenderId());

        // verify push message
        waitForEventProcessing();

        // Assert that pushToPersonLoud with ClientChatMessageReceivedEvent was triggered
        ClientChatMessageReceivedEvent pushedEvent = testClientPushService.getPushedEventToPersonLoud(sender,
                th.chat1Participant1.getPerson(),
                ClientChatMessageReceivedEvent.class,
                new PushCategory.PushCategoryId(th.chat1SubjectPushCategory.getId()));

        assertEquals(pushedEvent.getChatId(), chatId);
    }

    @Test
    public void chatMessageSendRequest_MediaMessage() throws Exception {

        long sentTime = System.currentTimeMillis();
        String chatId = th.chat1.getId();
        Person sender = th.chat1Participant2.getPerson();

        TemporaryMediaItem temporaryMediaItem = th.createTemporaryMediaItem(sender, sentTime + 100, sentTime);

        ClientChatMessageSendRequest chatMessageSendRequest = ClientChatMessageSendRequest.builder()
                .chatId(chatId)
                .message(null)
                .temporaryMediaItemId(temporaryMediaItem.getId())
                .sentTime(sentTime)
                .build();

        MvcResult result = mockMvc.perform(post("/communication/chat/event/chatMessageSendRequest")
                .headers(authHeadersFor(sender))
                .contentType(contentType)
                .content(json(chatMessageSendRequest)))
                .andReturn();

        ClientChatMessageSentConfirmation clientChatMessageSentConfirmation =
                toObject(result.getResponse(),
                        ClientChatMessageSentConfirmation .class);

        ClientChatMessage sentChatMessage = clientChatMessageSentConfirmation.getChatMessage();
        assertEquals(sentTime, sentChatMessage.getSentTime());
        assertFalse(sentChatMessage.isAutoGenerated());
        assertEquals(chatId, sentChatMessage.getChatId());
        assertNull(sentChatMessage.getMessage());
        assertEquals(temporaryMediaItem.getMediaItem().getId(), sentChatMessage.getMediaItem().getId());
        assertEquals(sender.getId(), sentChatMessage.getSenderId());

        // verify push message
        waitForEventProcessing();

        // Assert that pushToPersonLoud with ClientChatMessageReceivedEvent was triggered
        ClientChatMessageReceivedEvent pushedEvent = testClientPushService.getPushedEventToPersonLoud(sender,
                th.chat1Participant1.getPerson(),
                ClientChatMessageReceivedEvent.class,
                new PushCategory.PushCategoryId(th.chat1SubjectPushCategory.getId()));

        assertEquals(pushedEvent.getChatId(), chatId);
        assertEquals(0, th.temporaryMediaItemRepository.count());
    }

    @Test
    public void chatMessageSendRequest_SentTimeOutOfRange() throws Exception {

        String message = "Testing sendMessage from 💛  Chat💛Controller ☺";
        String chatId = th.chat1.getId();
        Person person = th.chat1Participant2.getPerson();
        //assume the message was sent days ago
        long actualSentTime = System.currentTimeMillis() - TimeUnit.DAYS.toMillis(1);
        //this is the earliest sent time that would be acceptable, it should be close to NOW
        long earliestSentTime = System.currentTimeMillis() - TimeUnit.SECONDS.toMillis(2);

        ClientChatMessageSendRequest chatMessageSendRequest = ClientChatMessageSendRequest.builder()
            .chatId(chatId)
            .message(message)
            .sentTime(actualSentTime)
            .build();

        MvcResult result = mockMvc.perform(post("/communication/chat/event/chatMessageSendRequest")
            .headers(authHeadersFor(person))
            .contentType(contentType)
            .content(json(chatMessageSendRequest)))
            .andReturn();

        ClientChatMessageSentConfirmation clientChatMessageSentConfirmation =
                toObject(result.getResponse(),
                        ClientChatMessageSentConfirmation .class);
        ClientChatMessage sentChatMessage = clientChatMessageSentConfirmation.getChatMessage();
        assertTrue(sentChatMessage.getSentTime() > earliestSentTime);
    }

    @Test
    public void chatMessageSendRequest_SenderBlockedByReceiver() throws Exception {

        String message = "Testing sendMessage from ChatController with blocked sender ☺";
        long sentTime = System.currentTimeMillis();
        String chatId = th.chat1.getId();
        Person sender = th.chat1Participant2.getPerson();
        Person receiver = th.chat1Participant1.getPerson();

        th.personBlockingRepository.saveAndFlush(PersonBlocking.builder()
                .app(th.app1)
                .blockingPerson(th.chat1Participant1.getPerson())
            .blockedPerson(sender)
            .build());

        ClientChatMessageSendRequest chatMessageSendRequest = ClientChatMessageSendRequest.builder()
                .chatId(chatId)
                .message(message)
                .sentTime(sentTime)
                .build();

        mockMvc.perform(post("/communication/chat/event/chatMessageSendRequest")
                .headers(authHeadersFor(sender))
                .contentType(contentType)
                .content(json(chatMessageSendRequest)))
                .andExpect(status().isOk());

        // verify push messages
        waitForEventProcessing();

        ClientChatMessageReceivedEvent forcedSilentPushedEvent = testClientPushService.getPushedEventToPersonLoud(
                sender,
                receiver,
                ClientChatMessageReceivedEvent.class,
                new PushCategory.PushCategoryId(th.chat1SubjectPushCategory.getId()));

        assertEquals(forcedSilentPushedEvent.getChatId(), chatId);
        // We expect a silent push from a loud push event, because the sender is blocked by the receiver
        Mockito.verify(testExternalPushProvider).sendMessageToPerson(Mockito.anySet(), Mockito.eq(receiver),
                Mockito.any(), Mockito.eq(false));

        ClientChatMessageReceivedEvent silentPushedEvent = testClientPushService.getPushedEventToPersonSilent(
                sender,
                ClientChatMessageReceivedEvent.class,
                Collections.singletonList(th.chat1SubjectPushCategory));

        assertEquals(silentPushedEvent.getChatId(), chatId);
        Mockito.verify(testExternalPushProvider).sendMessageToPerson(Mockito.anySet(), Mockito.eq(sender),
                Mockito.any(), Mockito.eq(false));

        testClientPushService.assertNoMorePushedEvents();
    }

    @Test
    public void chatMessageSendRequest_WrongParameters() throws Exception {

        String message = "Testing invalid sendMessage from ChatController ☺  ☯";
        long sentTime = System.currentTimeMillis();
        String chatId = th.chat1.getId();
        Person person = th.chat1Participant2.getPerson();

        Person notParticipant = th.personPoolingStationOp;
        assertFalse(th.chat1.getParticipants().stream()
                .map(ChatParticipant::getPerson)
                .anyMatch(p -> Objects.equals(p, notParticipant)));

        //not found chat
        ClientChatMessageSendRequest chatMessageSendRequest = ClientChatMessageSendRequest.builder()
                .chatId("invalidChatId")
                .message(message)
                .sentTime(sentTime)
                .build();

        mockMvc.perform(post("/communication/chat/event/chatMessageSendRequest")
                .headers(authHeadersFor(person))
                .contentType(contentType)
                .content(json(chatMessageSendRequest)))
                .andExpect(isException("invalidChatId", ClientExceptionType.CHAT_NOT_FOUND));

        //null chatId
        chatMessageSendRequest = ClientChatMessageSendRequest.builder()
                .chatId("xxx")
                .message(message)
                .sentTime(sentTime)
                .build();
        chatMessageSendRequest.setChatId(null);

        mockMvc.perform(post("/communication/chat/event/chatMessageSendRequest")
                .headers(authHeadersFor(person))
                .contentType(contentType)
                .content(json(chatMessageSendRequest)))
                .andExpect(isException("chatId", ClientExceptionType.EVENT_ATTRIBUTE_INVALID));

        //user is not participant
        chatMessageSendRequest = ClientChatMessageSendRequest.builder()
                .chatId(chatId)
                .message(message)
                .sentTime(sentTime)
                .build();

        mockMvc.perform(post("/communication/chat/event/chatMessageSendRequest")
                .headers(authHeadersFor(notParticipant))
                .contentType(contentType)
                .content(json(chatMessageSendRequest)))
                .andExpect(isException(chatId, ClientExceptionType.PERSON_NOT_CHAT_PARTICIPANT));

        //chatMessage is empty
        chatMessageSendRequest = ClientChatMessageSendRequest.builder()
                .chatId(chatId)
                .message("")
                .sentTime(sentTime)
                .build();

        mockMvc.perform(post("/communication/chat/event/chatMessageSendRequest")
                .headers(authHeadersFor(person))
                .contentType(contentType)
                .content(json(chatMessageSendRequest)))
                .andExpect(isException("message", ClientExceptionType.EVENT_ATTRIBUTE_INVALID));

        //chatMessage is null
        chatMessageSendRequest = ClientChatMessageSendRequest.builder()
                .chatId(chatId)
                .message(null)
                .sentTime(sentTime)
                .build();

        mockMvc.perform(post("/communication/chat/event/chatMessageSendRequest")
                .headers(authHeadersFor(person))
                .contentType(contentType)
                .content(json(chatMessageSendRequest)))
                .andExpect(isException("message", ClientExceptionType.EVENT_ATTRIBUTE_INVALID));

        //temporary media item id is invalid
        String invalidTemporaryMediaItemId = "4711";

        chatMessageSendRequest = ClientChatMessageSendRequest.builder()
                .chatId(chatId)
                .temporaryMediaItemId(invalidTemporaryMediaItemId)
                .sentTime(sentTime)
                .build();

        mockMvc.perform(post("/communication/chat/event/chatMessageSendRequest")
                        .headers(authHeadersFor(person))
                        .contentType(contentType)
                        .content(json(chatMessageSendRequest)))
                .andExpect(
                        isException(invalidTemporaryMediaItemId, ClientExceptionType.TEMPORARY_FILE_ITEM_NOT_FOUND));
    }

    @Test
    public void chatMessageSendRequest_Unauthorized() throws Exception {

        String message = "message";
        String chatId = th.chat1.getId();
        long sentTime = System.currentTimeMillis();

        ClientChatMessageSendRequest chatMessageSendRequest = ClientChatMessageSendRequest.builder()
                .chatId(chatId)
                .message(message)
                .sentTime(sentTime)
                .build();

        assertOAuth2(post("/communication/chat/event/chatMessageSendRequest")
                .content(json(chatMessageSendRequest))
                .contentType(contentType));
    }

    @Test
    public void chatMessageSendRequest_TextToLong() throws Exception {

        final String chatId = th.chat1.getId();
        final Person person = th.chat1Participant2.getPerson();
        final int charCount = communicationConfig.getMaxNumberCharsPerMessage() + 1;
        final String message = StringUtils.repeat('*', charCount);
        final long sentTime = System.currentTimeMillis();

        final ClientChatMessageSendRequest chatMessageSendRequest = ClientChatMessageSendRequest.builder()
                .chatId(chatId)
                .message(message)
                .sentTime(sentTime)
                .build();

        mockMvc.perform(post("/communication/chat/event/chatMessageSendRequest")
                .headers(authHeadersFor(person))
                .contentType(contentType)
                .content(json(chatMessageSendRequest)))
                .andExpect(isException(ClientExceptionType.EVENT_ATTRIBUTE_INVALID));
    }

    @Test
    public void chatReadRequest() throws Exception {

        long readTime = System.currentTimeMillis();
        final Chat chat = th.chat1;
        Person person = th.chat1Participant2.getPerson();

        final ClientChatReadRequest chatReadSetRequest = ClientChatReadRequest.builder()
                .chatId(chat.getId())
                .readTime(readTime)
                .build();

        mockMvc.perform(post("/communication/chat/event/chatReadRequest")
                .headers(authHeadersFor(person))
                .contentType(contentType)
                .content(json(chatReadSetRequest)))
                .andExpect(status().isOk());

        final ChatParticipant participant = th.chatParticipantRepository
                .findByChatAndPerson(th.chat1, person)
                .get();
        assertEquals(Long.valueOf(readTime), participant.getReadTime());
        assertEquals(chat.getId(), participant.getChat().getId());
        assertEquals(person.getId(), participant.getPerson().getId());
    }

    @Test
    public void chatReadRequest_InvalidAttributeValues() throws Exception {

        long readTime = System.currentTimeMillis();
        final Chat chat = th.chat1;
        Person person = th.chat1Participant2.getPerson();

        final ClientChatReadRequest chatReadSetRequestInvalidId = ClientChatReadRequest.builder()
                .chatId(BaseTestHelper.INVALID_UUID)
                .readTime(readTime)
                .build();

        mockMvc.perform(post("/communication/chat/event/chatReadRequest")
                .headers(authHeadersFor(person))
                .contentType(contentType)
                .content(json(chatReadSetRequestInvalidId)))
                .andExpect(isException(ClientExceptionType.CHAT_NOT_FOUND));

        final ClientChatReadRequest chatReadSetRequestReadTimeNull = ClientChatReadRequest.builder()
                .chatId(chat.getId())
                .readTime(0)
                .build();

        mockMvc.perform(post("/communication/chat/event/chatReadRequest")
                .headers(authHeadersFor(person))
                .contentType(contentType)
                .content(json(chatReadSetRequestReadTimeNull)))
                .andExpect(isException(ClientExceptionType.EVENT_ATTRIBUTE_INVALID));

        final ClientChatReadRequest chatReadSetRequestReadTimeToBig = ClientChatReadRequest.builder()
                .chatId(chat.getId())
                .readTime(Long.MAX_VALUE + 1)
                .build();

        mockMvc.perform(post("/communication/chat/event/chatReadRequest")
                .headers(authHeadersFor(person))
                .contentType(contentType)
                .content(json(chatReadSetRequestReadTimeToBig)))
                .andExpect(isException(ClientExceptionType.EVENT_ATTRIBUTE_INVALID));

        final ClientChatReadRequest chatReadSetRequestReadTimeNegative = ClientChatReadRequest.builder()
                .chatId(chat.getId())
                .readTime(-1)
                .build();

        mockMvc.perform(post("/communication/chat/event/chatReadRequest")
                .headers(authHeadersFor(person))
                .contentType(contentType)
                .content(json(chatReadSetRequestReadTimeNegative)))
                .andExpect(isException(ClientExceptionType.EVENT_ATTRIBUTE_INVALID));
    }

    @Test
    public void chatReadRequest_UserNotParticipant() throws Exception {

        long readTime = System.currentTimeMillis();
        final Chat chat = th.chat1;
        Person person = th.chat2Participant1.getPerson();

        final ClientChatReadRequest chatReadSetRequest = ClientChatReadRequest.builder()
                .chatId(chat.getId())
                .readTime(readTime)
                .build();

        mockMvc.perform(post("/communication/chat/event/chatReadRequest")
                .headers(authHeadersFor(person))
                .contentType(contentType)
                .content(json(chatReadSetRequest)))
                .andExpect(isException(ClientExceptionType.PERSON_NOT_CHAT_PARTICIPANT));
    }

    @Test
    public void chatReadRequest_Unauthorized() throws Exception {

        long readTime = System.currentTimeMillis();
        final Chat chat = th.chat1;

        final ClientChatReadRequest chatReadSetRequest = ClientChatReadRequest.builder()
                .chatId(chat.getId())
                .readTime(readTime)
                .build();

        assertOAuth2(post("/communication/chat/event/chatReadRequest")
                .content(json(chatReadSetRequest))
                .contentType(contentType));
    }

}
